from django.contrib.auth.models import User
from django.db.models.signals import post_save
from django.dispatch import receiver

from .models import UserProfile


@receiver(post_save, sender=User)
def create_user_profile(sender, instance, created, **kwargs):
    """用户创建时自动生成资料"""
    if created:
        UserProfile.objects.create(user=instance)


@receiver(post_save, sender=User)
def save_user_profile(sender, instance, **kwargs):
    """用户更新时同步保存资料"""
    try:
        instance.profile.save()
    except Exception as e:
        UserProfile.objects.get_or_create(user=instance)
        print('save_user_profile Error:', e)
